# ReGrowthExpandedWorldGeneration


![Image](https://i.imgur.com/buuPQel.png)

Update of Helixien, Taranchuks mod
https://steamcommunity.com/sharedfiles/filedetails/?id=2607979870
with permission

- Added a "Hide preview" button. Gives more room to biome and faction-settings and does not consume resources by regenerating the preview when changing values. 

![Image](https://i.imgur.com/pufA0kM.png)

	
![Image](https://i.imgur.com/Z4GOv8H.png)

**UPDATE 07.04.2022:** As of now this mod is officially discontinued and will not receive any updates or bug fixies. At the same time, I am making the mod "open-source", for a lack of better words, meaning anyone can change, expand and re-upload the mod as long as you:

- Keep the name
- Credit the original creators (Taranchuk and me)
- Link back to the old mod in the credits.

The entire mod, including code, can be found here:
https://github.com/Helixien/ReGrowth-Expanded-World-Generation]https://github.com/Helixien/ReGrowth-Expanded-World-Generation

![Image](https://i.imgur.com/7w5OFgC.png)


You can see all changes in the changelog tab!

**Current mod version: 0.9.2 BETA**
**Supports Rimworld version: 1.3**

The mod is in beta! It works fine 95% of the time, but there might be bugs we haven't yet found and some things probably could be fine tuned and optimized. 

![Image](https://i.imgur.com/Pe8cTXc.png)


# What is ReGrowth: Expanded World Generation?


Have you ever wished you could tweak the world you plan on to your liking? Remove certain biomes or roads? Make one biome spawn less or more? Make the world the size you want and not the one pre-selected for you? Have more mountains or only the sea with a few islands? Or save your world as a preset for later colonies? Or share that preset with a friend?

If your answer is yes, then **ReGrowth: Expanded World Generation** is the mod for you! Unlike all other ReGrowth mods, this one is **standalone**! You don't need ReGrowth:Core or anything else (other than Harmony). It's made for everyone! Whether you like my mods or not.

Enjoy!

![Image](https://i.imgur.com/uWt5Qba.png)


Here is an overview over everything you can control with **ReGrowth: Expanded World Generation**:

- **Global Coverage:** Is now a slider! Choose the percentage you want!
- **River Density:** Want more or less rivers? Now you can!
- **Mountain Density:** For all you hikers! Enjoy an alpine world… or one without any!
- **Sea level:** Make the sea rise or fall, whatever you like!
- **Axial Tilt::** Works exactly like in Realistic Planets and is fully compatible with it! Planets with higher axial tilts will have more extreme seasonal temperature shifts.
- **Road Density:** Control how many ancient and faction roads there are.

- **Biomes**: Control each and every biome you have, from vanilla to modded ones. Finally you can create ANY planet you can think of! From boreal worlds to sea worlds with desert islands or a Mars like hellscape. It's in your hands!

**Multiplier** multiplies the spawn value of the biome by the chosen percent.
**Offset** adds or removes the chosen amount from the spawn value.

Both sliders are added to allow more control over biomes. This will take some playing around for you to get the hang of and fully understand. If you just want to disable one, set the multiplier to 0%.

- **Factions:** Have not been changed. The game already allows a good amount of options here!

- **Presets:** Allows you to save and load presets, similar to how it works in “EdB Prepare Carefully”. Later we will allow modders to ship their own presets with their mods so they can share their version of a planet with you!

- **Planet Preview:** That one is something we added because we wanted to see if we can. And we could, but it has its limitations! Like the world you play on, each preview needs to be generated which can take quite a long time depending on whether you have a 30% coverage or a 100% one. **So be patient with it!** It does however not freeze your game and can be completely ignored. We will see if we can further optimize it in the future.

It does however allow you to see how the planet you are making would look with your current setting. It's not 3D, so you can't rotate it.

I also want to be clear that this mod has NO training wheels. You can go crazy with it. If you make a sea ice world and set the temps to maximum you get 70 °C ice sheets. You can do whatever you want!

![Image](https://i.imgur.com/QnAx6zL.png)


We tried to make it work with as many other mods we could right away, here is a list:

- Realistic Planets
- My Little Planet
- Rimwar
- Colony Groups
- Roads of the Rim
- Any modded biome.

However there are mods that are, as of now, not working with it:

- Prepare Landing: We tried to make it work, but they must look into it from their side.

![Image](https://i.imgur.com/toezrwG.png)


**Q: Can this mod be added to an existing save?**
A: Yes, but it doesnt really help you in any way.

**Q: Can this mod be removed from a save?**
A: Yes, as far as we know you can! You will get some red errors after loading your save, but they should be harmless.

**Q: Can I make world type X?**
A: Yes, with enough time you should be able to tweak and fine tune the planet to your liking!

**Q: Can I share a preset with my friend?**
A: No, not yet, but that will come! Right now you can only save and load them yourself!

**Q: Why should I use this mod?**
A: Because why not? 

**Q: The preview takes forever!**
A: Yep, it does. It needs to render a nearly full world, just like when you click generate. It is only a little bit faster. Why we added it then? Because we could.

**Q: Does it scale with the UI?**
A: Yes, altho there might be some issues left we haven't found. Please report them!

**Q: Does it require ReGrowth: Core?**
A: No!

![Image](https://i.imgur.com/fXBb4DJ.png)


- C# Code done by Taranchuk. This is his masterpiece, I just had the idea! If you love the mod, please show him your love!

Rimworld is owned by Tynan Sylvester and he wants you to finally buy his book!  


https://discord.gg/7befJWr9xS]![Image](https://i.imgur.com/cfoFEMA.png)


![Image](https://i.imgur.com/PwoNOj4.png)



-  See if the the error persists if you just have this mod and its requirements active.
-  If not, try adding your other mods until it happens again.
-  Post your error-log using https://steamcommunity.com/workshop/filedetails/?id=818773962]HugsLib and command Ctrl+F12
-  For best support, please use the Discord-channel for error-reporting.
-  Do not report errors by making a discussion-thread, I get no notification of that.
-  If you have the solution for a problem, please post it to the GitHub repository.



